PROGRAM SB_Musik1;

{ Include the SBC Unit, and any other units needed }
uses sbc_tp6, dos, crt;

CONST
  { Instrumente }
  inst : array[0..9] of array[0..15] of byte =
                ( ( $21,$11,$4c,$00,$f1,$f2,$63,$72,
                    $00,$00,$04,$00,$00,$00,$00,$00 ),

                  ( $a5,$b1,$d2,$80,$81,$f1,$03,$05,
                    $00,$00,$02,$00,$00,$00,$00,$00 ),

                  ( $71,$62,$1c,$05,$51,$52,$03,$13,
                    $00,$00,$0e,$00,$00,$00,$00,$00 ),

                  ( $11,$01,$8a,$40,$f1,$f1,$11,$b3,
                    $00,$00,$06,$00,$00,$00,$00,$00 ),

                  ( $21,$11,$11,$00,$a3,$c4,$43,$22,
                    $02,$00,$0d,$00,$00,$00,$00,$00 ),

                  ( $31,$a1,$1c,$80,$41,$92,$0b,$3b,
                    $00,$00,$0e,$00,$00,$00,$00,$00 ),

                  ( $71,$62,$c5,$05,$6e,$8b,$17,$0e,
                    $00,$00,$02,$00,$00,$00,$00,$00 ),

                  ( $41,$91,$83,$00,$65,$32,$05,$74,
                    $00,$00,$0a,$00,$00,$00,$00,$00 ),

                  ( $32,$16,$87,$80,$a1,$7d,$10,$33,
                    $00,$00,$08,$00,$00,$00,$00,$00 ),

                  ( $01,$13,$8d,$00,$51,$52,$53,$7c,
                    $01,$00,$0c,$00,$00,$00,$00,$00 ) );
CONST
     Tempo = 40;
     stacc = 10;

VAR
    i,c,d,e,f,g       : integer;
    Ton, Laenge       : integer;
    Melodie           : String;
{ ---------------------------------------------------------------- }
PROCEDURE Bildschirm;
BEGIN
    
    clrscr;
    GotoXY(32,2);
    Write('mr - soft  1993');
    GotoXY(16,4);
    write('M U S I K   U N D   S T R I N G S    Programm 3');
    GotoXY(16,5);
    write('***********************************************');
   
END;
{ ---------------------------------------------------------------- }
PROCEDURE Melodie_Eingabe;
BEGIN
 Window(20,7,80,15);
 clrscr;
  writeln ('Melodie eingeben (Tne c..h) - maximal 40 Toene');
  writeln ('         < P > oder < p >  fr Pause');
  writeln ('          mit <RETURN> abschliessen');
  writeln;writeln;
  for i := 1 to 40 do
        write ('.');
        gotoXY(1,6);
      readln (Melodie);
      
  Window (1,1,80,25);
END;
{ ---------------------------------------------------------------- }
PROCEDURE zeige(i:integer);
BEGIN
   GotoXY(1+i*2,16);write (Melodie[i],' ');
END;
{ ---------------------------------------------------------------- }
PROCEDURE spiele(Ton,Laenge:integer);
VAR
    i,j : word;
    Instrument : byte;

BEGIN
   Instrument := 0;
   sbfd_program_change(0,instrument);
    if Ton=0 then
    BEGIN
        delay(Laenge);delay(stacc);
    END else
    BEGIN
            sbfd_note_on(0,Ton,$40);
                delay (Laenge); 
                 delay (stacc);
            sbfd_note_off(0,Ton,$40);
   END;
END;
{ ---------------------------------------------------------------- }
PROCEDURE Zeichen2Ton ;
BEGIN
   Case Melodie[i] of
          'c' : Ton := 60; 
          'd' : Ton := 62;
          'e' : Ton := 64;
          'f' : Ton := 65;
          'g' : Ton := 67;
          'a' : Ton := 69;
          'h' : Ton := 71;
          '.' : Ton := 0; 
          END;   { von Case }
END;
{ ---------------------------------------------------------------- }
PROCEDURE revers ;
BEGIN
   Case Melodie[i] of
          'c' : Melodie[i] := 'h'; 
          'd' : Melodie[i] := 'a';
          'e' : Melodie[i] := 'g';
          'g' : Melodie[i] := 'e';
          'a' : Melodie[i] := 'd';
          'h' : Melodie[i] := 'c';
          END;   { von Case }
END;
{ ---------------------------------------------------------------- }
PROCEDURE lies_String;
BEGIN
  Window(1,16,80,18);
 clrscr;
 gotoxy(30,1);
 writeln('M E L O D I E :');writeln;
for i := 1 to Length(Melodie) do
    BEGIN
    case  Melodie[i] of
    'P', 'p' : Melodie[i] := '.';
    END; { von case }
          zeige(i);
          Zeichen2Ton;
          spiele (Ton, 200);
    END;
END;
{ ---------------------------------------------------------------- }
PROCEDURE rueckwaerts;
BEGIN
  Window(1,16,80,18);
 clrscr;
 gotoxy(30,1);
 writeln('K R E B S :     '); writeln;
for i := Length(Melodie) downto 1 do
    BEGIN
         zeige(i);
         Zeichen2Ton;
         spiele (Ton, 200);
    END;
END;
{ ---------------------------------------------------------------- }
PROCEDURE Spiegel;
BEGIN
  Window(1,16,80,18);
 clrscr;
 gotoxy(30,1);
 writeln('S P I E G E L :     '); writeln;
for i := 1 to Length(Melodie)  do
    BEGIN
         revers;
         zeige(i);
         Zeichen2Ton; 
         spiele (Ton, 200);
    END;
END;
{ ---------------------------------------------------------------- }
PROCEDURE Spiegelkrebs;
BEGIN
  Window(1,16,80,18);
 clrscr;
 gotoxy(30,1);
 writeln('S P I E G E L K R E B S:  '); writeln;
for i := Length(Melodie) downto 1 do
    BEGIN
         revers;
         zeige(i);
         Zeichen2Ton;
         spiele (Ton, 200);
    END;
END;


{ ---------------------------------------------------------------- }
PROCEDURE Ablauf;
BEGIN
    Bildschirm;
    Melodie_Eingabe;
     GotoXY(24,22);
    Write('Ende mit beliebiger Taste');
    repeat
      BEGIN
        lies_String;
        delay (400);
        rueckwaerts;
        delay (400);
        Spiegel;
        delay(400);
        Spiegelkrebs;
        delay(400);
      END;
    until keypressed;
END;

{ ------------------------------------------------------------------------ }
                           { Hauptprogramm }
BEGIN

    if GetEnvSetting = 0 then
    BEGIN

        if boolean( sbc_check_card and $0002 ) then
        BEGIN
            clrscr;
            Textcolor(14);Textbackground(1);
            sbfd_init;
            sbfd_instrument(@inst);

              Ablauf;

            sbfd_reset;
        END
        else
            writeln('Sound-Blaster-Karte nicht gefunden oder falsches I/O-Setting.');
    END
    else
        writeln('BLASTER-Environment-Variable nicht gesetzt, unvollstndig oder falsch.');

end.
